#! /usr/bin/env ruby
require "numru/gphys"
include NumRu

################
$nx=16
$ny=17
$ndays=1
#################

y_a=VArray.new(NArray.sfloat($ny).indgen, 
            {"long_name"=>"grid index for y direction", "unit"=>"non"}, "j")
y = Axis.new.set_pos(y_a)

ym_idx = NArray.sfloat($ny).indgen
ym_idx[0]=0.5
ym_idx[$ny-1]=ym_idx[$ny-1]-0.5

y_am=VArray.new(ym_idx, 
            {"long_name"=>"grid index for y direction", "unit"=>"non"}, "jm")
ym = Axis.new.set_pos(y_am)

t_a=VArray.new(NArray.sfloat(1).indgen + 130, 
            {"long_name"=>"days", "unit"=>"days"}, "days")
t = Axis.new.set_pos(t_a)

na_temper=NArray.sfloat($ny, $ndays)
na_temper[0..8, 0]=[30.1, 30.1, 28.2, 25.0, 20.8, 15.9, 10.8, 5.4, 0.0]
na_temper[9..16, 0]=-na_temper[7..0, 0]
p na_temper

data_T2=VArray.new(na_temper, 
    {"long_name"=>"temperature at level2", "unit"=>"K"}, "T2")


na_u4=NArray.sfloat($ny, $ndays)
na_u4[0..8, 0]=[0.0, -0.3, -0.6, -0.9, -1.0, -1.0, -1.1, -1.1, -1.1]
na_u4[9..16, 0]=na_u4[7..0,0]

data_u4 = VArray.new(na_u4, 
    {"long_name"=>"zonal velocity at level4", "unit"=>"m^2/s"}, "u4")


na_u1=NArray.sfloat($ny, $ndays)
na_u1[0..8, 0]=[0.0, 6.1, 16.9, 24.9, 30.1,33.3, 35.1, 36.0, 36.3]
na_u1[9..16, 0]=na_u1[7..0,0]

data_u1 = VArray.new(na_u1, 
    {"long_name"=>"zonal velocity at level1", "unit"=>"m^2/s"}, "u1")

na_u2 = NArray.sfloat($ny, $ndays)
na_u2[0..8, 0]=[0.0, 4.0, 11.0, 16.3, 19.8, 21.8, 23.0, 23.6, 23.8]
na_u2[9..16, 0]=na_u2[7..0,0]
data_u2 = VArray.new(na_u2, 
    {"long_name"=>"zonal velocity at level2", "unit"=>"m^2/s"}, "u2")

na_V1=NArray.sfloat($ny, $ndays)
na_V1[0..8, 0]=[0.0, 0.011, 0.025, 0.030, 0.028, 0.027, 0.029, 0.028, 0.029]
na_V1[9..16, 0]=na_V1[7..0,0]

data_V1 = VArray.new(na_V1, 
    {"long_name"=>"meriodinal velocity at level1", "unit"=>"m^2/s"}, "V1")


na_zeta1=NArray.sfloat($ny, $ndays)
na_zeta1[0..8, 0]=[0.0, -1.84e-5, -1.52e-5, -1.04e-5, -0.64e-5, -0.38e-5, -0.20e-5, -0.08e-5, 0.0]
na_zeta1[9..16, 0]=-na_zeta1[7..0,0]

data_zeta1 = VArray.new(na_zeta1, 
    {"long_name"=>"vorticity at level1", "unit"=>"/s"}, "zeta1")

ncfile = NetCDF.create("phillips_zonal_mean.nc")
grid_yt = Grid.new(y,t)
grid_ymt = Grid.new(ym,t)

GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_T2))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_u1))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_u2))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_u4))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_ymt, data_V1))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_zeta1))
ncfile.close

