#! /usr/bin/env ruby
require "numru/gphys"
include NumRu

################
$nx=16
$ny=17
$ndays=168
#################

def read_datas(filename, na_obj)
 lines = File.open(filename, "r").readlines
 for nday in 0..$ndays-1  
  target_lineNo = nday
	line = lines[target_lineNo]
	dat1 = line.split(" ")
        dat1.delete_at(0)
	#p dat1.size
        data_n1 = NArray.to_na(dat1)
	n=0
        data_n1.each{ |val|
		na_obj[n, nday] = val.to_f
		n=n+1
	}
    #p na_obj[true, nday]
  end
end

y_a=VArray.new(NArray.sfloat($ny).indgen, 
            {"long_name"=>"grid index for y direction", "unit"=>"non"}, "j")
y = Axis.new.set_pos(y_a)

ym_idx = NArray.sfloat($ny-1).indgen+0.5
y_am=VArray.new(ym_idx, 
            {"long_name"=>"grid index for y direction", "unit"=>"non"}, "jm")
ym = Axis.new.set_pos(y_am)

t_a=VArray.new(NArray.sfloat($ndays).indgen, 
            {"long_name"=>"days", "unit"=>"days"}, "days")
t = Axis.new.set_pos(t_a)

na_temper=NArray.sfloat($ny, $ndays)
read_datas("T_mean.dat", na_temper)
data_T2=VArray.new(na_temper, 
    {"long_name"=>"temperature at level2", "unit"=>"K"}, "T2")


na_u4=NArray.sfloat($ny, $ndays)
read_datas("u4_mean.dat", na_u4)

na_u4[1..$ny-2, true]=na_u4[0..$ny-3,true]
na_u4[0, true]=0.0
na_u4[$ny-1, true]=0.0
data_u4 = VArray.new(na_u4, 
    {"long_name"=>"zonal velocity at level4", "unit"=>"m^2/s"}, "u4")


na_u1=NArray.sfloat($ny, $ndays)
read_datas("u1_mean.dat", na_u1)

na_u1[1..$ny-2, true]=na_u1[0..$ny-3,true]
na_u1[0, true]=0.0
na_u1[$ny-1, true]=0.0
data_u1 = VArray.new(na_u1, 
    {"long_name"=>"zonal velocity at level1", "unit"=>"m^2/s"}, "u1")

na_u3 = NArray.sfloat($ny, $ndays)
read_datas("u3_mean.dat", na_u3)
na_u3[1..$ny-2, true]=na_u3[0..$ny-3,true]
na_u3[0, true]=0.0
na_u3[$ny-1, true]=0.0
data_u3 = VArray.new(na_u3, 
    {"long_name"=>"zonal velocity at level3", "unit"=>"m^2/s"}, "u3")

na_V1=NArray.sfloat($ny-1, $ndays)

read_datas("V1_mean.dat", na_V1)
data_V1 = VArray.new(na_V1, 
    {"long_name"=>"meriodinal velocity at level1", "unit"=>"m^2/s"}, "V1")


na_zeta1=NArray.sfloat($ny, $ndays)
na_zeta1[1..$ny-2, true]=na_zeta1[0..$ny-3,true]
na_zeta1[0, true]=0.0
na_zeta1[$ny-1, true]=0.0
read_datas("vorticity_1_mean.dat", na_zeta1)
data_zeta1 = VArray.new(na_zeta1, 
    {"long_name"=>"vorticity at level1", "unit"=>"/s"}, "zeta1")

na_Vp=NArray.sfloat($ny, $ndays)
read_datas("Vp_mean.dat", na_Vp)
data_Vp = VArray.new(na_Vp, 
    {"long_name"=>"vertical velocity at level2", "unit"=>"Pa/s"}, "omega2")

ncfile = NetCDF.create("zonal_mean.nc")
grid_yt = Grid.new(y,t)
grid_ymt = Grid.new(ym,t)

GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_T2))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_u1))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_u3))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_u4))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_ymt, data_V1))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_zeta1))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_yt, data_Vp))
ncfile.close

