#! /usr/bin/env ruby
require "numru/gphys"
require "numru/ggraph"
include NumRu

gphys_T2 = GPhys::IO.open('zonal_mean.nc', 'T2')

start_days=130

levels1 = NArray.float(25).indgen!*1.0
levels1[] = levels1[] - 14.0
levels = NArray.float(21).indgen!*1.0
levels[] = levels[] - 14.0

mj = DCL.udpget('indxmj')
mn = DCL.udpget('indxmn')

#DCL::gropn(4)
DCL::swpset('ldump', true)
DCL::gropn(4)
DCL::sgpset('lcntl', false)
DCL.sgpset('lfprop', true)
DCL::uzfact(0.9)

expr1end_T2 = gphys_T2.val[true, 130]
na_accumT2 = gphys_T2.val - expr1end_T2 
data_accumT2 = VArray.new(na_accumT2, 
    {"long_name"=>"accumlated change of T2", "unit"=>"K/day"}, "ac_T2")
accum_T2 = GPhys.new(gphys_T2.grid_copy, data_accumT2)

GGraph.set_fig('viewport'=>[0.05,0.90, 0.25,0.75])
GGraph.tone(accum_T2.cut(true, 130..160), true, 'levels'=>levels1, 'exchange'=>true)
#GGraph.contour(gphys_u4.cut(true, 129..164), false, 'levels'=>levels1, 
#   'index'=> mn, 'exchange'=>true)
GGraph.contour(accum_T2.cut(true,130..160), false, 
   'levels'=>levels, 'index'=>[mj, mn], 'line_type'=>[1, 2], 'exchange'=>true)
GGraph.color_bar
DCL::grcls
