#! /usr/bin/env ruby
require "numru/ggraph"
include NumRu

gphys_T2 = GPhys::IO.open('sf4_T2.nc', 'T2')
gphys_sf4 = GPhys::IO.open('sf4_T2.nc', 'sf4')
period = 163 #gphys_T2.axis('days').length

s_days=132
cntr_num = (gphys_sf4.val[true,true,s_days-1..period-1].max-gphys_sf4.val[true,true,s_days-1..period-1].min)/6.4e06
levels1 = 6.4e06 * (NArray.float(cntr_num.to_i+1).indgen!)
levels1[] = levels1[] + gphys_sf4.val[true,true,s_days-1..period-1].min

levels2 = NArray.int(14).indgen!(-35, 5)
lbl2 = NArray.int(7).indgen!(-30, 10)
mj = DCL.udpget('indxmj')
mn = DCL.udpget('indxmn')

#DCL::gropn(4)
DCL::swpset('ldump', true)
DCL::gropn(4)
DCL::sgpset('lcntl', false)
DCL.sgpset('lfprop', true)
DCL::uzfact(0.9)

for i in s_days-1..period-1
 GGraph.tone(gphys_sf4.cut(true, true, i), true, 'levels'=>levels1)
 GGraph.contour(gphys_sf4.cut(true, true, i), false, 'levels'=>levels1, 
   'index'=> mn)
 GGraph.contour(gphys_T2.cut(true, true, i), false, 
   'levels'=>levels2, 'index'=>[mn, mj], 'line_type'=>[2])
 GGraph.color_bar
 #DCL::grcls
end
