#! /usr/bin/env ruby

require "numru/gphys"
require "numru/ggraph"
include NumRu

load "param_setup.rb"

start_days = 141
av_days = 11
r_i = 1..15
r_iup = r_i.first+1..r_i.last+1
r_idwn = r_i.first-1..r_i.last-1

period=start_days..start_days+(av_days-1)
gphys_T2 = GPhys::IO.open('zonal_mean.nc', 'T2')
gphys_Vp2 = GPhys::IO.open('zonal_mean.nc', 'omega2')

na_DTDt = NArray.float(15)
na_DaHt = NArray.float(15).indgen!(1.0)
na_AdHt = NArray.float(15)
na_VrDif = NArray.float(15)
na_HtFlx = NArray.float(15)

na_T2 = NArray.float(15+2)
na_Vp2 = NArray.float(15+2)
na_T2 = gphys_T2.val[true, period].mean(1)
na_Vp2 = gphys_Vp2.val[true, period].mean(1)

na_DTDt[] = (gphys_T2.val[r_i, period.last] - gphys_T2.val[r_i, period.first])/av_days
na_DaHt[] = - (na_DaHt[] - 8.0)* Dy * 2.0 * H / ( Cp * W ) * One_day
na_AdHt[] = F0**2 * na_Vp2[r_i] / ( R * Lambda2 * P2 ) * One_day
na_VrDif[] = A * ( na_T2[r_iup] + na_T2[r_idwn] - 2.0 * na_T2[r_i] ) / Dy**2 * One_day
na_HtFlx = na_DTDt - na_DaHt - na_AdHt - na_VrDif

for i in 0..na_DTDt.total-1
  puts "#{na_DTDt[i]} #{na_DaHt[i]} #{na_AdHt[i]} #{na_HtFlx[i]} #{na_VrDif[i]}"
end
