#include "Field_Data_Manager.h"
#include "Param_List.h"

using namespace GMathLib;

Field_Data_Manager::Field_Data_Manager()
:p_stream_mx(0)
{
}


Field_Data_Manager::~Field_Data_Manager()
{

   // ̃NXIuWFNgj鎞,̃NXō쐬ꂽsIuWFNg
   // j
   if(p_stream_mx){
       for(int i=0; i < SF_ARRAY_SIZE; i++){
           delete p_stream_mx[i];
           delete p_stream_mean_mx[i];
       }

       for(int i=0; i < SF_DISTB_ARRAY_SIZE; i++){
           delete p_stream_distb_mx[i];
       }

       for(int i=0; i < PV_ARRAY_SIZE; i++){
	   delete p_pv_mx[i];
       }

       for(int i=0; i < PV_MN_DT_SIZE; i++){
           delete p_pv_mean_mx[i];
           delete p_pv_distb_mx[i];
       }

       delete [] p_stream_mx;
       delete [] p_stream_mean_mx; delete [] p_stream_distb_mx;

       delete [] p_pv_mx;
       delete [] p_pv_mean_mx;  delete [] p_pv_distb_mx;

       delete p_omega_mx;
       delete p_omega_mean_mx;  delete p_omega_distb_mx;
       
       for(int i=0; i < VR_ARRAY_SIZE; i++){
           delete p_vr_mx[i];
           delete p_vr_mean_mx[i];  delete p_vr_distb_mx[i];
        }

	delete [] p_vr_mx;
	delete [] p_vr_mean_mx;
	delete [] p_vr_distb_mx;
   }

   
}


bool Field_Data_Manager::Init_Field_Data(const Param_List& pm_list)
{
    // ̔zvfłsIuWFNg쐬.

    // ֐p̍sIuWFNg̃mۂ.
    p_stream_mx = new GMatrix*[SF_ARRAY_SIZE];
    p_stream_mean_mx = new GVector*[SF_ARRAY_SIZE];
    p_stream_distb_mx = new GMatrix*[SF_DISTB_ARRAY_SIZE];
    
    for(int i=0; i < SF_ARRAY_SIZE; i++){
        p_stream_mx[i] = new GMatrix(pm_list.num_x, pm_list.num_y);
        p_stream_mean_mx[i] = new GVector(pm_list.num_y);
        
    }
    
    for(int i=0; i < SF_DISTB_ARRAY_SIZE; i++){
        p_stream_distb_mx[i] = new GMatrix(pm_list.num_x, pm_list.num_y);
        p_stream_distb_mx[i]->Fill(0.0);
    }
    
    // |eVQxp̍sIuWFNg̃mۂ.
    p_pv_mx = new GMatrix*[PV_ARRAY_SIZE];
    p_pv_mean_mx = new GVector*[PV_ARRAY_SIZE];
    p_pv_distb_mx = new GMatrix*[PV_ARRAY_SIZE];
    
    for(int i=0; i < PV_ARRAY_SIZE; i++){
	p_pv_mx[i] = new GMatrix(pm_list.num_x, pm_list.num_y);
    }

    for(int i=0; i < PV_MN_DT_SIZE; i++){
        p_pv_mean_mx[i] = new GVector(pm_list.num_y);
        p_pv_distb_mx[i] = new GMatrix(pm_list.num_x, pm_list.num_y);
	p_pv_distb_mx[i]->Fill(0.0);
    }

    //  p xp̍sIuWFNg̃mۂ.
    p_omega_mx = new GMatrix(pm_list.num_x, pm_list.num_y);
    p_omega_mean_mx = new GVector(pm_list.num_y);
    p_omega_distb_mx = new GMatrix(pm_list.num_x, pm_list.num_y);
    
    // Qxp̍sIuWFNg̃mۂ.
    p_vr_mx = new GMatrix*[VR_ARRAY_SIZE];
    p_vr_mean_mx = new GVector*[VR_ARRAY_SIZE];
    p_vr_distb_mx = new GMatrix*[VR_ARRAY_SIZE];

    for(int i=0; i < VR_ARRAY_SIZE; i++){
        p_vr_mx[i] = new GMatrix(pm_list.num_x, pm_list.num_y);
        p_vr_mean_mx[i] = new GVector(pm_list.num_y);
        p_vr_distb_mx[i] = new GMatrix(pm_list.num_x, pm_list.num_y);
    }

    //֐̏lݒ肷.
    
    p_stream_mx[SF_LAYER1_AFTER]->Fill(pm_list.INIT_STREAM_FC1);
    p_stream_mx[SF_LAYER3_AFTER]->Fill(pm_list.INIT_STREAM_FC3);

    p_stream_mean_mx[SF_LAYER1_AFTER]->Fill(pm_list.INIT_STREAM_FC1);
    p_stream_mean_mx[SF_LAYER3_AFTER]->Fill(pm_list.INIT_STREAM_FC3);
    
    p_stream_mx[SF_LAYER1_BEFORE]->Fill(pm_list.INIT_STREAM_FC1);
    p_stream_mx[SF_LAYER3_BEFORE]->Fill(pm_list.INIT_STREAM_FC3);

    p_stream_mean_mx[SF_LAYER1_BEFORE]->Fill(pm_list.INIT_STREAM_FC1);
    p_stream_mean_mx[SF_LAYER3_BEFORE]->Fill(pm_list.INIT_STREAM_FC3);
    
    return true;
}


void Field_Data_Manager::Update_Field_Data(){
 
    // 1^CXebv̎ԔWvẐ, ef[^e( t+1, t, t-1 )p
    // sIuWFNgɓւ

    // |eVQxf[^̍XV
    p_pv_mx[PV_LAYER1_BEFORE2]->Copy(*p_pv_mx[PV_LAYER1_BEFORE]);
    p_pv_mx[PV_LAYER1_BEFORE]->Copy(*p_pv_mx[PV_LAYER1_AFTER]);
    
    p_pv_mx[PV_LAYER3_BEFORE2]->Copy(*p_pv_mx[PV_LAYER3_BEFORE]);
    p_pv_mx[PV_LAYER3_BEFORE]->Copy(*p_pv_mx[PV_LAYER3_AFTER]);

    // ֐̃f[^̍XV
    p_stream_mx[SF_LAYER1_BEFORE]->Copy(*p_stream_mx[SF_LAYER1_AFTER]);
    p_stream_mx[SF_LAYER3_BEFORE]->Copy(*p_stream_mx[SF_LAYER3_AFTER]);

    p_stream_mean_mx[SF_LAYER1_BEFORE]->Copy(*p_stream_mean_mx[SF_LAYER1_AFTER]);
    p_stream_mean_mx[SF_LAYER3_BEFORE]->Copy(*p_stream_mean_mx[SF_LAYER3_AFTER]);
    
    p_stream_distb_mx[SF_DISTB_LAYER1_BEFORE2]->Copy(*p_stream_distb_mx[SF_DISTB_LAYER1_BEFORE]);
    p_stream_distb_mx[SF_DISTB_LAYER1_BEFORE]->Copy(*p_stream_distb_mx[SF_DISTB_LAYER1_AFTER]);

    p_stream_distb_mx[SF_DISTB_LAYER3_BEFORE2]->Copy(*p_stream_distb_mx[SF_DISTB_LAYER3_BEFORE]);
    p_stream_distb_mx[SF_DISTB_LAYER3_BEFORE]->Copy(*p_stream_distb_mx[SF_DISTB_LAYER3_AFTER]);
}


