

#ifndef FIELD_DATA_MANAGEMENT_H
#define FIELD_DATA_MANAGEMENT_H

#include "Param_List.h"

//include GMathLib header
#include <gmathcore/GMatrix.h>
#include <gmathcore/GVector.h>
#include <gfd/GConstants.h>

using namespace GMathLib;
using namespace GMathLib::GFD::GConstants;


/**
 * V~[VŊ֌W镨̍sf[^ǗNX
 */
class Field_Data_Manager
{
public:
    /**
     * RXgN^
     */
    Field_Data_Manager();

    /**
     * fXgN^
     */
    ~Field_Data_Manager();

    /**
     * ۊǂ̂ɕKv GMatrix IuWFNg̃mۂ֐
     */
    bool Init_Field_Data(const Param_List& pm_list);

    /**
     * ֐ێĂsIuWFNg̃|C^擾֐
     */
    GMatrix* Get_Stream_Func(int layer_tag){
	if(-1 < layer_tag < SF_ARRAY_SIZE){
	     return p_stream_mx[layer_tag];
	}else{
	    return 0;
	}
    }

    /**
     * ֐̓ϏێĂsIuWFNg̃|C^擾֐
     */
    GVector* Get_Stream_Func_Mean(int layer_tag){
        
	if(-1 < layer_tag < SF_ARRAY_SIZE){
	     return p_stream_mean_mx[layer_tag];
	}else{
	    return 0;
	}
    }

    /**
     * ֐̏ێĂsIuWFNg̃|C^擾֐
     */
    GMatrix* Get_Stream_Func_Disturb(int layer_tag){
        
	if(-1 < layer_tag < SF_DISTB_ARRAY_SIZE){
	     return p_stream_distb_mx[layer_tag];
	}else{
	    return 0;
	}
    }


    /**
     * |eVQxێĂsIuWFNg̃|C^擾֐
     */
    GMatrix* Get_PV(int layer_tag){
        
	if(-1 < layer_tag < PV_ARRAY_SIZE){
	     return p_pv_mx[layer_tag];
	}else{
	    return 0;
	}
    }


    /**
     * |eVQx̓ϏێĂsIuWFNg̃|C^擾֐
     */
    GVector* Get_PV_Mean(int layer_tag){
        
	if(-1 < layer_tag < PV_MN_DT_SIZE ){
	     return p_pv_mean_mx[layer_tag];
	}else{
	    return 0;
	}
    }

    /**
     * |eVQx̏ێĂsIuWFNg̃|C^擾֐
     */
    GMatrix* Get_PV_Disturb(int layer_tag){
        
	if(-1 < layer_tag < PV_MN_DT_SIZE){
	     return p_pv_distb_mx[layer_tag];
	}else{
	    return 0;
	}
    }


    /**
     *  p xێĂsIuWFNg̃|C^擾֐
     */
    GMatrix* Get_Omega(){
        return p_omega_mx;
    }


    /**
     *  p x̓ϏێĂsIuWFNg̃|C^擾֐
     */
    GVector* Get_Omega_Mean(){
        return p_omega_mean_mx;
    }
    

    /**
     *  p x̏ێĂsIuWFNg̃|C^擾֐
     */
    GMatrix* Get_Omega_Disturb(){
        return p_omega_distb_mx;
    }

    /**
     * QxێĂsIuWFNg̃|C^擾֐
     */
    GMatrix* Get_Vorcity(int layer_tag){
        if( -1 < layer_tag < VR_ARRAY_SIZE){
            return p_vr_mx[layer_tag];
	}else{
	    return 0;
	}
    }

    /**
     * Qx̓ϏێĂsIuWFNg̃|C^擾֐
     */
    GVector* Get_Vorcity_Mean(int layer_tag){
        if( -1 < layer_tag < VR_ARRAY_SIZE){
            return p_vr_mean_mx[layer_tag];
	}else{
	    return 0;
	}
    }
    
    /**
     * Qx̏ێĂsIuWFNg̃|C^擾֐
     */
    GMatrix* Get_Vorcity_Disturb(int layer_tag){
        if( -1 < layer_tag < VR_ARRAY_SIZE){
            return p_vr_distb_mx[layer_tag];
	}else{
	    return 0;
	}
    }
    
    // esf[^ɂ, AFTER => BEFORE, BEFORE => BEFORE2 ւƍsf[^
    // ꂩ.
    void Update_Field_Data();


public:
    // |eVQxf[^ƂĎsIuWFNg̃|C^̔z̃CfbNX̒`
    const static int PV_LAYER1_AFTER = 0;
    const static int PV_LAYER1_BEFORE = 1;
    const static int PV_LAYER1_BEFORE2 = 2;
    const static int PV_LAYER3_AFTER = 3;
    const static int PV_LAYER3_BEFORE = 4;
    const static int PV_LAYER3_BEFORE2 = 5;
    const static int PV_MEAN_LAYER1 = 0;
    const static int PV_MEAN_LAYER3 = 1;
    const static int PV_DISTB_LAYER1 = 0;
    const static int PV_DISTB_LAYER3 = 1;
    
    // ֐̏f[^ƂĎsIuWFNg̃|C^̔z̃CfbNX̒`
    const static int SF_LAYER1_AFTER = 0;
    const static int SF_LAYER1_BEFORE = 1;
    const static int SF_LAYER3_AFTER = 2;
    const static int SF_LAYER3_BEFORE = 3;
    const static int SF_BAROTOPIC_MODE = 4;
    const static int SF_BAROCLINIC_MODE = 5;

    const static int SF_DISTB_LAYER1_AFTER = 0;
    const static int SF_DISTB_LAYER1_BEFORE = 1;
    const static int SF_DISTB_LAYER1_BEFORE2 = 2;
    const static int SF_DISTB_LAYER3_AFTER = 3;
    const static int SF_DISTB_LAYER3_BEFORE = 4;
    const static int SF_DISTB_LAYER3_BEFORE2 = 5;

    // Qxf[^ƂĎsIuWFNg̃|C^̔z̃CfbNX̒`
    const static int VR_LAYER1 = 0;
    const static int VR_LAYER3 = 1;

private:

    // ֐̏̃f[^ێsIuWFNg̃|C^̔z̃|C^̐錾
    //
    // ̔z, 250 hPa ( t)E750 hPa ( t)E[h(250 hPa +750 hPa)E
    // X[h(250hPa - 750 hPa)̗֐̏vfɎsIuWFNg
    // \Ă.܂,̔zvfɑΉtCfbNX,
    // ̃NXŒ`Ă.
    // 
    // ̔zvf擾邽߂ɂ,̃NX̃Qb^[ĂԂƂɂȂ.

    GMatrix **p_stream_mx;        /**< ֐f[^ƂsIuWFNg̃|C^̔z|C^@*/
    GMatrix **p_stream_distb_mx;  /**< ֐̏f[^ƂsIuWFNg̃|C^̔z|C^ */
    GVector **p_stream_mean_mx;   /**< ֐̊{f[^ƂsIuWFNg̃|C^̔z|C^ */

    const static int SF_ARRAY_SIZE = 6; /**< ̊esIuWFNg̔z̃TCY */
    const static int SF_DISTB_ARRAY_SIZE = 6; 

    // |eVQx̃f[^ێsIuWFNg̃|C^̔z̃|C^̐錾
    //
    // ̔z, 250 hPa ( t+1, t, t-1)E750 hPa ( t+1, t, t-1)̗֐̏
    // vfɎsIuWFNgō\Ă.܂,̔zvfɑΉt
    // ĂCfbNX,̃NXŒ`Ă.
    //
    // ̔zvf擾邽߂ɂ,̃NX̃Qb^[ĂԂƂɂȂ.
    
    GMatrix **p_pv_mx;        /**< |eVQxf[^ƂsIuWFNg̃|C^̔z|C^@*/
    GMatrix **p_pv_distb_mx;  /**< |eVQx̏f[^ƂsIuWFNg̃|C^̔z|C^ */
    GVector **p_pv_mean_mx;   /**< |eVQx̊{f[^ƂsIuWFNg̃|C^̔z|C^ */
    
    const static int PV_ARRAY_SIZE = 6; /**< ̊esIuWFNg̔z̃TCY */
    const static int PV_MN_DT_SIZE = 2;
 
    GMatrix* p_omega_mx;
    GMatrix* p_omega_distb_mx;
    GVector* p_omega_mean_mx;

   
    GMatrix **p_vr_mx;
    GMatrix **p_vr_distb_mx;
    GVector **p_vr_mean_mx;

    const static int VR_ARRAY_SIZE = 2;
};

#endif
