#ifndef PARAMETER_LIST_H
#define PARAMETER_LIST_H

#include <string>
#include <util/GProperties.h>

/**
 *
 */
class Param_List
{
public:
    
    /** 
     * RXgN^Ăяoۂ, V~[Vp[^vpeBt@C
     * ǂݍ, Param_List NX public ϐɃZbg.
     */
    Param_List(std::string param_file_name)
    {
        GMathLib::Util::GProperties prop;
	prop.Load(param_file_name);
        // ep[^̈ꗗ\
	prop.Print_All_Properties();

	del_x = prop.GetProperty_d("del_x");
	del_y = prop.GetProperty_d("del_y");
	num_x = prop.GetProperty_d("num_x");
	num_y = prop.GetProperty_d("num_y");
	vertical_stability = prop.GetProperty_d("vertical_stability");
        end_time = prop.GetProperty_d("end_time");
        beta = prop.GetProperty_d("beta");
        A = prop.GetProperty_d("A");
        k = prop.GetProperty_d("k");
	del_t = prop.GetProperty_d("del_t");
	H = prop.GetProperty_d("H");
	f0 = prop.GetProperty_d("f0");
        p2 = 5.0e04;

	// ֐̏vZ
        INIT_STREAM_FC1 = INIT_GEOPOTENTIAL1 / f0;
	INIT_STREAM_FC3 = INIT_GEOPOTENTIAL3 / f0;
    }


    double del_x;              /**< ̋ԕ [m] */
    double num_x;              /**< ̋ԕ */
    
    double del_y;              /**< k̋ԕ [m] */
    double num_y;              /**< k̋ԕ */
    
    double vertical_stability; /**< ̈x [m^(-2)] */
    
    double del_t;              /**< P^CXebv̎Ԃ̍ݕ [s] */
    double end_time;           /**< V~[V̏I [s] */

    double f0;                 /**< RIp[^ [s^(-1)] */
    double beta;               /**< Rossby p[^ [s^(-1) m^(-1)] */

    double H;                  /**< ˉM [J kg^(-1) s^(-1)] */

    double A;                  /**< QgUW [m^2 s^(-1)] */
    double k;                  /**< n\C [s^(-1) ] */
    
    // ֐̏
    double INIT_STREAM_FC1; /** < 250 hPa ̗֐̏ */
    double INIT_STREAM_FC3; /** < 750 hPa ̗֐̏ */

    const static double INIT_GEOPOTENTIAL1 = 0.0; // 250 hPa ɂ鐅̈͐ۓ\WI|eV
    const static double INIT_GEOPOTENTIAL3 = 0.0; // 750 hPa ɂ鐅̈͐ۓ\WI|eV

    double p2; /** < p_2 = 500 hPa */
};

#endif
