#include <iostream>

#include "Param_List.h"
#include "Field_Data_Manager.h"
#include "Output_Data.h"
#include "Data_Analysis.h"
#include "Forecast.h"
#include "Thermodyn_Energy_Analysis.h"

// GMathLib 𗘗p̂ɕKvȃwb_[t@CCN[h
#include <gmathcore/GMatrix.h>
#include <util/GProgress_Bar.h>

using namespace GMathLib;
using namespace GMathLib::Util;

/*
 * vg^Cv錾
 */
void Output_Work(Output_Data& output, Param_List& pm_list, Field_Data_Manager& data_manager);
void Output_Energy_Cycle(Param_List& pm, Field_Data_Manager& data_manager, Data_Analysis& analysis, double now_time);

/**
 *
 */
int main()
{
    // Kvȃp[^ێ Parameter_List NX̃IuWFNg錾.
    // , 'Parameter.list' V~[Vp[^ǂݍ.
    Param_List pm_list("Parameter.list");

    // ֐̏, |eVQx̊ef[^ێsIuWFNg,
    // Ǘ Field_Data_Manager NX̃IuWFNg錾, .
    Field_Data_Manager data_manager;
    data_manager.Init_Field_Data(pm_list);

    // ۂɎxz̎Ԑϕs,P^CXebv̕\
    // Forecast NX̃IuWFNg錾.
    Forecast forecast(pm_list);
    Data_Analysis analysis;
    Output_Data output;

    // V~[VI܂łɕKvȃ^CXebvvZ
    int end_time_step = pm_list.end_time / pm_list.del_t;
    int oneday_tick = (int) (24.0 * 3600.0 / ( pm_list.del_t ) );
    double now_time = 0;
    
    GProgress_Bar bar;
    bar.Prepair(end_time_step, "");
    
    // vZ[vɓO Forecast NX̏֐Ăяo.
    // ŏ͏ɑ΂̌vZ, OFF ɂĂ.
    forecast.Prepair(pm_list, data_manager);
    forecast.Enable_Disturb_Eq(false);
    
    // ɂ镨AEgvbgĂ.
    Output_Work(output, pm_list, data_manager);
    
    
    // vZ[v
    // 1 ^CXebv|eVQxԐϕĂ.
    for(int i=0; i < end_time_step; i++){	 
         
	 // |eVQx̎ԔWvZ
         forecast.Calc_PV_Time_Evol(pm_list, data_manager);
         
	 // \|eVQxꂩ, ̕ffIɋ߂.
	 forecast.Diagnose_Stream_Function(pm_list, data_manager);
	 forecast.Diagnose_v_p_Velocity(pm_list, data_manager);
	 forecast.Diagnose_Vorcity(pm_list, data_manager);

	 // Forecast NXێĂ^CxJE^XV.
	 forecast.Increment_TimeStep();
	 
      
	 // 130 days ɒB
	 // ̍ۏɑ΂ on ɂ.
         if( (double) i / oneday_tick == 131 ){
	      std::cout << "Create disturbed field" << std::endl;
	      forecast.Create_Disturb_Field(pm_list, data_manager);
	      forecast.Enable_Disturb_Eq(true);
              forecast.Set_First_Run();
	 }
	 
	 // e함ʂ̃f[^(average of After and Before)AEgvbg.
	 if( i % oneday_tick  == 0 ){
              output.Output_Energy_Energy_Transform(pm_list, data_manager);
	 }
         
	 // ̃^CXebv֍sO,
	 // |eVQx̕ϐ̃f[^,AFTER => BEFORE, BEFORE => BEFORE2
	 // ւƓւ.
         data_manager.Update_Field_Data();
         
	 // e함ʂ̃f[^(Before)AEgvbg.
	 if( i % oneday_tick  == 0 ){
              Output_Work(output, pm_list, data_manager);
	 }

         // eIuWFNg̃JE^XV.
	 now_time += pm_list.del_t;
	 output.Update_Time(now_time);
	 bar.Update_Counter();
    }
    
    return 0;
}

void Output_Work(Output_Data& output, Param_List& pm_list, Field_Data_Manager& data_manager)
{
    output.Output_Mean_PV3_Data(pm_list, data_manager);
    output.Output_Mean_SF1_Data(pm_list, data_manager);
    output.Output_Mean_SF3_Data(pm_list, data_manager);
    output.Output_Mean_Temparature_Data(pm_list, data_manager);
    output.Output_Mean_u1(pm_list, data_manager);
    output.Output_Mean_u3(pm_list, data_manager);
    output.Output_Mean_u4(pm_list, data_manager);
    output.Output_Mean_V1(pm_list, data_manager);
    output.Output_Mean_Vorcity1(pm_list, data_manager);
    
    output.Output_Temperature_Data(pm_list, data_manager);
    output.Output_Vp_Data(pm_list, data_manager);
    output.Output_Mean_Vp_Data(pm_list, data_manager);
    //output.Output_Disturb_SF4_Data(pm_list, data_manager);
    output.Output_SF4_Data(pm_list, data_manager);
}


void Output_Energy_Cycle(Param_List& pm_list, Field_Data_Manager& data_manager, Data_Analysis& analysis, double now_time)
{
    std::cout << "t=" << now_time + pm_list.del_t/2 << std::endl;

    std::cout << "KM: " <<  analysis.K_Mean(pm_list, data_manager) << ",  ";//std::endl;
    std::cout << "PM: " <<  analysis.P_Mean(pm_list, data_manager) << std::endl;
    std::cout << "KD: " <<  analysis.K_Disturb(pm_list, data_manager) << ",  ";//std::endl;
    std::cout << "PD: " <<  analysis.P_Disturb(pm_list, data_manager) << std::endl;
    
    std::cout << "{QM, PM}: " <<  analysis.Mean_Q_To_Mean_P(pm_list, data_manager) << std::endl;
    
    std::cout << "{PM, PD}: " <<  analysis.Mean_P_To_Disturb_P(pm_list, data_manager) << ", ";
    std::cout << "{KD, KM}: " <<  analysis.Disturb_K_To_Mean_K(pm_list, data_manager) << std::endl;
    
    std::cout << "{PM, KM}: " <<  analysis.Mean_P_To_Mean_K(pm_list, data_manager) << ", ";
    std::cout << "{PD, KD}: " <<  analysis.Disturb_P_To_Disturb_K(pm_list, data_manager) << std::endl;
    
    std::cout << "{PM, A}: " <<  analysis.Mean_P_To_A(pm_list, data_manager) << ", ";//std::endl;
    std::cout << "{PD, A}: " <<  analysis.Disturb_P_To_A(pm_list, data_manager) << std::endl;
    
    std::cout << "{KM, A}: " <<  analysis.Mean_K_To_A(pm_list, data_manager) << ", ";
    std::cout << "{KD, A}: " <<  analysis.Disturb_K_To_A(pm_list, data_manager) << std::endl;
    
    std::cout << "{KM, k}: " <<  analysis.Mean_K_To_k(pm_list, data_manager) << ", ";//std::endl;
    std::cout << "{KD, k}: " <<  analysis.Disturb_K_To_k(pm_list, data_manager) << std::endl;
    
    std::cout << std::endl;
}
